<!doctype html public "-//W3C//DTD Bikeshed 2016-09//EN">
<meta charset=utf-8>
<title>CSS Mobile Profile 2.0</title>
<style type="text/css">
    table.features th {
        background: #00589f;
        color: #fff;
        text-align: left;
        padding: 0.2em 0.2em 0.2em 0.5em;
    }
    table.features td {
        vertical-align: top;
        border: 1px solid #ccc;
        padding: 0.3em 0.3em 0.3em 0.7em;
    }
    tr.optional { background: aqua; }
	em.rfc2119 {
	    text-transform: lowercase;
	    font-variant: small-caps;
	    font-style: normal
    }
</style>
<pre class=metadata>
Title: CSS Mobile Profile 2.0
Shortname: css-mobile
Group: csswg
Level:
Status: ED
Work status: abandoned
TR: https://www.w3.org/TR/css-mobile/
ED: https://drafts.csswg.org/css-mobile/
Previous version: https://www.w3.org/TR/2014/NOTE-css-mobile-20141014/
Editor: Bert Bos, W3C, bert@w3.org, w3cid 3343
!Previous editors: Svante Schubert, Sun Microsystems Inc.
!Previous editors: Robin Berjon, Expway
Default Biblio Status: snapshot
Abstract:
  <p>This specification defines in general a subset of <acronym
  title="Cascading Style Sheets">CSS</acronym> 2.1 [[!CSS21]] that is
  to be considered a baseline for interoperability between
  implementations of <acronym title="Cascading Style
  Sheets">CSS</acronym> on constrained devices (e.g. mobile phones).
  Its intent is <em>not</em> to produce a profile of <acronym
  title="Cascading Style Sheets">CSS</acronym> incompatible with the
  complete specification, but rather to ensure that implementations
  that due to platform limitations cannot support the entire
  specification implement a common subset that is interoperable not
  only amongst constrained implementations but also with complete
  ones. Additionally, this specification aligns itself as much as
  possible with the <acronym title="Open Mobile
  Alliance">OMA</acronym> Wireless <acronym title="Cascading Style
  Sheets">CSS</acronym> 1.1 [[WCSS11]] specification. At the same
  time, <acronym title="Open Mobile Alliance">OMA</acronym> is doing
  alignment work in <acronym title="Open Mobile
  Alliance">OMA</acronym> Wireless <acronym title="Cascading Style
  Sheets">CSS</acronym> 1.2 [[WCSS12]]. It is aimed at aligning the
  mandatory compliance items between <acronym title="Cascading Style
  Sheets">CSS</acronym> Mobile Profile 2.0 and <acronym title="Open
  Mobile Alliance">OMA</acronym> Wireless <acronym title="Cascading
  Style Sheets">CSS</acronym> 1.2 [[WCSS12]].</p>

  <p class=mtb><strong>This profile is obsolete. Please see the latest
  <a href="https://www.w3.org/TR/CSS/" >CSS Snapshot</a> for the
  specifications that make up CSS.</strong></p>
Status text:
  <p><em>At this time, the CSS Working Group does not envisage further
  work on this specification and does not plan to propose it as a W3C
  Recommendation.</em></p>
</pre>




<h2 id=introduction>Introduction</h2>
<p>This document specifies a profile of <acronym title="Cascading Style Sheets">CSS</acronym> that is in general based on <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 [[!CSS21]], but requires as well new features from <acronym title="Cascading Style Sheets">CSS</acronym> 3. In addition the document defines an <em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em> feature set, that is suggested to be implemented by more advanced user agents.</p>


<h2 id=conf>Conformance</h2>
    <p>
      The key words  of
    descriptive assertions and RFC 2119 terminology. The key words "MUST",
    "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT",
    "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in
RFC 2119 [[!RFC2119]].
    </p>
        <p>
            Since the goal of this specification is to define a baseline interoperability level, user
            agents <em class="rfc2119" title="Keyword in RFC 2119 context">MAY</em> accept <acronym title="Cascading Style Sheets">CSS</acronym> documents conforming to <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 or subsequent revisions of the <acronym title="Cascading Style Sheets">CSS</acronym>
            family of Recommendations.
        </p>
        <p>
            In order to conform to this specification, user agents, authoring tools, and content <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em>
            conform to the <a href="http://www.w3.org/TR/CSS21/conform.html#conformance">Conformance</a>
            and <a href="http://www.w3.org/TR/CSS21/conform.html#errors">Error conditions</a>
            section of the <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 specification [[!CSS21]], with the following modifications.
        </p>
        <ol>
            <li>
                Only features marked as supported in this specification are <em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em>.
                Aside of the <em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED </em> feature set,
                an additional <em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em> feature set is given, that may be implemented by more advanced user agents.
                This feature set is <em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em> by the <acronym title="Compound Document Formats">CDF</acronym> as in [[!WICDMobile10]].
                Support for a larger set of <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 is <em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em>.
            </li>
            <li>
                The requirement concerning which <a href="http://www.w3.org/TR/CSS21/media.html"><acronym title="Cascading Style Sheets">CSS</acronym> 2.1 media types</a>
                are supported is tightened so that both the <code>handheld</code> and <code>all</code> media
                types <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em> be accepted and processed. Other media types <em class="rfc2119" title="Keyword in RFC 2119 context">MAY</em> be accepted and processed as well.
            </li>
            <li>
                The requirements that user agents <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em> make it possible to select an alternate style sheet
                amongst those linked from the document, as well as provide for a way to turn off author style
                sheets, are relaxed to be <em class="rfc2119" title="Keyword in RFC 2119 context">RECOMMENDED</em> behavior, but not <em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em>.
            </li>
        </ol>

<h2 id="selectors">Selectors</h2>
    <p>
            Selectors are defined in the <a href="http://www.w3.org/TR/CSS21/selector.html">Selectors</a>
            chapter of the <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 specification [[!CSS21]]. The following table identifies which selector
            constructs <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em> be supported amongst those defined by <acronym title="Cascading Style Sheets">CSS</acronym> 2.1.
        </p>
        <table class="features" summary="Selectors of CSS mobile profile 2.0">
            <tbody><tr>
                <th>Selector type</th>
                <th>Example</th>
                <th>Meaning</th>
                <th>Conformance</th>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#universal-selector">Universal selector</a></td>
                <td><code>*</code></td>
                <td>Matches any element.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#type-selectors">Type selectors</a></td>
                <td><code>E</code></td>
                <td>Matches any E element.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#descendant-selectors">Descendant selectors</a></td>
                <td><code>E F</code></td>
                <td>Matches any F element that is a descendant of an E element.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#child-selectors">Child selectors</a></td>
                <td><code>E &gt; F</code></td>
                <td>Matches any F element that is a child of an element E.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#link-pseudo-classes">The link pseudo-classes</a></td>
                <td><code>E:link</code></td>
                <td>Matches element E if E is the source anchor of a hyperlink, unvisited by a user.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#link-pseudo-classes">The link pseudo-classes</a></td>
                <td><code>E:visited</code></td>
                <td>Matches element E if E is the source anchor of a hyperlink, visited by a user.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#dynamic-pseudo-classes">The dynamic pseudo-classes</a></td>
                <td><code>E:active</code></td>
                <td>Matches element E if E is being activated by the user.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#dynamic-pseudo-classes">The dynamic pseudo-classes</a></td>
                <td><code>E:focus</code></td>
                <td>Matches element E if E has the focus (accepts keyboard events or other forms of text input).</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#class-html">Class selectors</a></td>
                <td><code>.warning</code></td>
                <td>
                    <em>Language specific</em>. (In (X)HTML, matches elements whose <code>class</code> attribute contains a
                    token with the same name.)
                </td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#id-selectors">ID selectors</a></td>
                <td><code>#myid</code></td>
                <td>Matches any element with an ID equal to "myid".</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/selector.html#grouping">Grouping</a></td>
                <td><code>E1, E2, E3 { ... }</code></td>
                <td>Matches a group of elements, which share the same style declarations.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
        </tbody></table>

<h2 id="at-rules">At-rules</h2>
    <p>
            At-rules are defined in the <a href="http://www.w3.org/TR/CSS21/syndata.html#at-rules">at-rules</a>
            section of the <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 specification [[!CSS21]]. The following table identifies which at-rule
            constructs <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em> be supported amongst those defined by <acronym title="Cascading Style Sheets">CSS</acronym>
            by setting the at-rule as <em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em> in the table's last column.
            Only at-rules that are part of the suggested feature set for advanced user agents are listed here as <em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em>.
        </p>
        <table class="features" summary="At-rules of CSS mobile profile 2.0">
            <tbody><tr>
                <th>Rule</th>
                <th>Definition</th>
                <th>Conformance</th>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/syndata.html#charset">@charset</a></td>
                <td>Defines character encoding for the style sheet.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/cascade.html#at-import">@import</a></td>
                <td>Imports an external style sheet.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td><a href="http://www.w3.org/TR/CSS21/media.html#at-media-rule">@media</a></td>
                <td>Groups a set of style rules to apply only to one or more particular media.
                	<br>Only the <code>handheld</code> and <code>all</code> media
                types <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em> be accepted and processed. Other media types <em class="rfc2119" title="Keyword in RFC 2119 context">MAY</em> be accepted and processed as well.</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr class="optional">
                <td><a href="http://www.w3.org/TR/css3-namespace/#declaration">@namespace</a></td>
                <td>For declaring the default namespace and binding namespaces to namespace prefixes. </td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
        </tbody></table>

<h2 id="properties">Properties</h2>
    <p>
        Properties are defined in several chapters of the <acronym title="Cascading Style Sheets">CSS</acronym> 2.1
        specification [[!CSS21]] and in case of marquee properties in the <acronym title="Cascading Style Sheets">CSS</acronym> Marquee Module [[!CSS3MARQUEE]]. The following table identifies which properties
        <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em> be supported amongst those defined by
        <acronym title="Cascading Style Sheets">CSS</acronym> by setting the property as <em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em> in the table's last column.
         Only properties that are part of the suggested feature set for advanced user agents are listed here as <em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em>.
        The property syntax is provided (expressed using the same <a href="http://www.w3.org/TR/CSS21/about.html#value-defs">value specifications</a>
        as <acronym title="Cascading Style Sheets">CSS</acronym> 2.1) when it is subsetted from the original.
        Limitations that apply to a property apply equally to its shorthand alternative.
        </p>
        <table class="features" summary="Properties of CSS mobile profile 2.0">
            <tbody><tr>
                <th>Property</th>
                <th>Syntax (if different from <acronym title="Cascading Style Sheets">CSS</acronym>)</th>
                <th>Conformance</th>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/colors.html#propdef-background-color">background-color</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/colors.html#propdef-background-image">background-image</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/colors.html#propdef-background-repeat">background-repeat</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/colors.html#propdef-background-attachment">background-attachment</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/colors.html#propdef-background-position">background-position</a>
                </td>
                <td><code>top | center | bottom | left | right | inherit</code></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/colors.html#propdef-background">background</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-top-width">border-top-width</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-right-width">border-right-width</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-bottom-width">border-bottom-width</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-left-width">border-left-width</a><br>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-width">border-width</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-top-color">border-top-color</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-right-color">border-right-color</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-bottom-color">border-bottom-color</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-left-color">border-left-color</a><br>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-color">border-color</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-top-style">border-top-style</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-right-style">border-right-style</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-bottom-style">border-bottom-style</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-left-style">border-left-style</a><br>
                </td>
                <td><code>none | solid | dashed | dotted | inherit</code></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-style">border-style</a>
                </td>
                <td><code>none | solid | dashed | dotted | inherit</code></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-top">border-top</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-right">border-right</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-bottom">border-bottom</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border-left">border-left</a><br>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-border">border</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#position-props">bottom</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#propdef-clear">clear</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/colors.html#propdef-color">color</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#propdef-display">display</a>
                </td>
                <td><code>inline | block | list-item | none | inherit</code></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#propdef-float">float</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/fonts.html#propdef-font-family">font-family</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr><tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/fonts.html#propdef-font-style">font-style</a>
                </td>
        <td>
      </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/fonts.html#propdef-font-variant">font-variant</a>
                </td>
        <td>
      </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/fonts.html#propdef-font-weight">font-weight</a>
                </td>
        <td>
      </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/fonts.html#propdef-font-size">font-size</a>
                </td>
                <td><code>&lt;absolute-size&gt; | &lt;relative-size&gt; | inherit</code>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/fonts.html#propdef-font">font</a>
                </td>
        <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visudet.html#propdef-height">height</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#position-props">left</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/generate.html#propdef-list-style-type">list-style-type</a>
                </td>
                <td>
                    <code>disc | circle | square | decimal | lower-roman | upper-roman | lower-alpha
                    | upper-alpha | none | inherit</code>
                </td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/generate.html#propdef-list-style-image">list-style-image</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/generate.html#propdef-list-style">list-style</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-margin-top">margin-top</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-margin-right">margin-right</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-margin-bottom">margin-bottom</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-margin-left">margin-left</a><br>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-margin">margin</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    marquee-direction [[!CSS3MARQUEE]]
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    marquee-loop [[!CSS3MARQUEE]]
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>marquee-speed [[!CSS3MARQUEE]]
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>marquee-style [[!CSS3MARQUEE]]
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visudet.html#propdef-max-height">max-height</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visudet.html#propdef-max-width">max-width</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visudet.html#propdef-min-height">min-height</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visudet.html#propdef-min-width">min-width</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
      <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/ui.html#propdef-outline-color">outline-color</a>
        </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td></tr>
      <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/ui.html#propdef-outline-style">outline-style</a>
                </td>
                <td><code>none | solid | dashed | dotted | inherit</code></td><td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td></tr>
    <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/ui.html#propdef-outline-width">outline-width</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
            <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/ui.html#dynamic-outlines">outline</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
            <tr>
                <td>
                    overflow  [[!CSS21]]
                </td>
                <td>auto</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    overflow-style [[!CSS3MARQUEE]]
                </td>
                <td>marquee</td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-padding-top">padding-top</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-padding-right">padding-right</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-padding-bottom">padding-bottom</a><br>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-padding-left">padding-left</a><br>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/box.html#propdef-padding">padding</a>
                </td>
        <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#choose-position">position</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
            <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#position-props">right</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/text.html#propdef-text-indent">text-indent</a>
                </td>
        <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/text.html#propdef-text-align">text-align</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/text.html#propdef-text-decoration">text-decoration</a>
                </td>
                <td><code>none | blink |underline | inherit</code></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/text.html#propdef-text-transform">text-transform</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#position-props">top</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visudet.html#propdef-vertical-align">vertical-align</a>
                </td>
                <td><code>top | middle | bottom | baseline | inherit</code></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visufx.html#propdef-visibility">visibility</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/text.html#propdef-white-space">white-space</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td></tr>
            <tr>
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visudet.html#propdef-width">width</a>
                </td>
                <td></td>
                <td><em class="rfc2119" title="Keyword in RFC 2119 context">REQUIRED</em></td>
            </tr>
            <tr class="optional">
                <td>
                    <a href="http://www.w3.org/TR/CSS21/visuren.html#z-index">z-index</a>
                </td>
                <td>
            </td><td><em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></td></tr>
        </tbody></table>
<h3 class="no-num no-toc" id="informative-note">Informative Notes</h3>
    <ul>
    <li id="css-best-practise">
        Content Providers will reach a larger and more satisfied audience by following Mobile Web Best Practices [[MOBILE-BP]] and <acronym title="Cascading Style Sheets">CSS</acronym> Techniques for Web Content Accessibility Guidelines [[WCAG10-CSS-TECHS]].
    </li>
    <li id="wcss-extensions">
        The <acronym title="Open Mobile Alliance">OMA</acronym> Wireless <acronym title="Cascading Style Sheets">CSS</acronym> 1.1 [[WCSS11]] introduced
        three extensions <code>Marquee</code>, <code>Access Keys</code> and <code>Input</code>.
        Those extensions are deprecated in <acronym title="Open Mobile Alliance">OMA</acronym> Wireless <acronym title="Cascading Style Sheets">CSS</acronym> 1.2 [[WCSS12]]. The <code>Marquee</code> functionality has been redefined by the marquee properties of the <acronym title="Cascading Style Sheets">CSS</acronym> 3 box model [[!CSS3MARQUEE]]
    </li>
    </ul>


<h2 id="syntax">Syntax</h2>
    <p>
        A user agent <em class="rfc2119" title="Keyword in RFC 2119 context">MUST</em> support all value types defined in the
        <a href="http://www.w3.org/TR/CSS21/syndata.html#values">Values</a> section of the
        <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 specification [[!CSS21]], with the following exceptions:
    </p>
        <ol>
            <li>Support for <a href="http://www.w3.org/TR/CSS21/syndata.html#counter">counter values</a> is <em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em></li>
            <li>
                Support for <a href="http://www.w3.org/TR/CSS21/ui.html#system-colors">CSS2 System Colors</a>
                and <a href="http://www.w3.org/TR/CSS21/ui.html#system-fonts">User preferences for fonts</a>
                is <em class="rfc2119" title="Keyword in RFC 2119 context">OPTIONAL</em>.
            </li>
        </ol>



<h2 class="no-num" id="acknow">Acknowledgments</h2>
    <p>
    The editors wish to thank the authors of the previous version of this document,
    Ted Wugofski (Openwave), Doug Dominiak (Openwave, formerly Motorola),
    Peter Stark (Ericsson), and Tapas Roy (Openwave), as well as the authors of
    the <acronym title="Open Mobile Alliance">OMA</acronym> Wireless <acronym title="Cascading Style Sheets">CSS</acronym> specifications and the <acronym title="Cascading Style Sheets">CSS</acronym> 2.1 specification.
    Furthermore, the editors want to thank the <acronym title="Compound Document Formats">CDF</acronym> <acronym title="Working Group">WG</acronym> for their participation on this specification.
    </p>

</body></html>
