<h1>Requirements for Latin Text Layout and Pagination</h1>
<style type="text/css">

blockquote p { font-style: italic; }
p.source { text-align: right; font-style: normal }
</style>
<pre class='metadata'>
Status: ED
Shortname: dpub-latinreq
Group: dpub
Level: 1
Repository: w3c/dpub-pagination
ED: http://w3c.github.io/dpub-pagination/
TR: http://www.w3.org/TR/dpub-latinreq/
Previous Version: http://www.w3.org/TR/2014/WD-dpub-latinreq-20140313/
Editor: Dave Cramer, Hachette Livre, dave.cramer@hbgusa.com
Abstract: This document describes requirements for pagination and layout of books that use the Latin script, based on the tradition of print book design and composition. It is hoped that these principles can inform the pagination of digital content as well, and serve as a reference for the CSS Working Group and other interested parties. This work was inspired by [[JLREQ]].

</pre>
<h2  class="no-num no-toc" id=sotd>
Status of This Document
</h2>

<em>This section describes the status of this document at the time of its publication. Other documents may supersede this document. A list of current <abbr title="World Wide Web Consortium">W3C</abbr> publications and the latest revision of this technical report can be found in the <a href="http://www.w3.org/TR/"><abbr title="World Wide Web Consortium">W3C</abbr> technical reports index</a> at http://www.w3.org/TR/.</em>
        
<strong>This is a work in progress. No section should be considered final, and the absence of any content does not imply that such content is out of scope, or may not appear in the future. If you feel something should be covered here, tell us!</strong> The initial version of this document will focus on books, and at this time will not include requirements specific to magazines or newspapers. The scope will depend heavily on the willingness of people to contribute to this document. Please contact the Digital Publishing Interest Group if you would like to help. Once the document is stable, the group will publish it as an Interest Group Note.

This document was published by the <a href="http://www.w3.org/dpub/IG/">Digital Publishing Interest Group</a> as an Editor's Draft. If you wish to make comments regarding this document, please send them to <a href="mailto:public-digipub@w3.org">public-digipub@w3.org</a> (<a href="mailto:public-digipub-request@w3.org?subject=subscribe">subscribe</a>, <a href="http://lists.w3.org/Archives/Public/public-digipub/">archives</a>). All comments are welcome.
            
Publication as an Editor's Draft does not imply endorsement by the <abbr title="World Wide Web Consortium">W3C</abbr> Membership. This is a draft document and may be updated, replaced or obsoleted by other documents at any time. It is inappropriate to cite this document as other than work in progress.

This document was produced by a group operating under the <a id="sotd_patent" property="w3p:patentRules" href="http://www.w3.org/Consortium/Patent-Policy-20040205/">5 February 2004 <abbr title="World Wide Web Consortium">W3C</abbr> Patent Policy</a>. <abbr title="World Wide Web Consortium">W3C</abbr> maintains a <a href="" rel="disclosure">public list of any patent disclosures</a> made in connection with the deliverables of the group; that page also includes instructions for disclosing a patent. An individual who has actual knowledge of a patent which the individual believes contains <a href="http://www.w3.org/Consortium/Patent-Policy-20040205/#def-essential">Essential Claim(s)</a> must disclose the information in accordance with <a href="http://www.w3.org/Consortium/Patent-Policy-20040205/#sec-Disclosure">section 6 of the <abbr title="World Wide Web Consortium">W3C</abbr> Patent Policy</a>.

This document is governed by the <a id="w3c_process_revision" href="http://www.w3.org/2014/Process-20140801/">1 August 2014 <abbr title="World Wide Web Consortium">W3C</abbr> Process Document</a>.



<h2 id="intro">
Introduction
</h2>
Not all stories worth telling can fit in a tweet, on a computer screen, or on a single piece of paper. Ever since the codex replaced the scroll, humans have divided our stories into pages. Pagination is the art and the craft of turning that scroll of content into discrete pieces, whether destined for book pages or screens. Pagination requires us to think about the document at all levels, from the total number of pages to the tiny spaces between letters. Along with graphic design and typography, it determines the look of the page. 

<blockquote>
	<p>Typography is the craft of endowing human language with a durable visual form, and thus with an independent existence.
	<p class="source">
		—Robert Bringhurst, <i>The Elements of Typographic Style</i>
</blockquote>

Good pagination, like good typography, aims to be invisible. As the reader turns the page, the stream of words and images in her mind should not be interrupted. Two thousand years of experience have taught us how best to do this. The goal of this document is to describe those rules, as clearly as possible, so they can be implemented in the Open Web Platform. We hope for a day where the pagination of digital books will be as beautiful and transparent as the best printed books.


Note: Our goal is for this document to describe layout and pagination for all languages that use the Latin script. 


<h2 id="fundamentals">
Fundamentals
</h2>
<blockquote>
	<p>
		Makeup is a highly skilled procedure. If the text is merely divided mechanically into portions of equal length, without regard to where the divisions fall, some of the pages that result are bound to be unacceptable logically or aesthetically: they will incorporate bad breaks.
	</p>
	<p class="source">
		—<i>Chicago Manual of Style, 14th Edition</i>, 19.40.
	</p>
</blockquote>
<blockquote>
	<p>
		What therefore God hath joined together, let not man put asunder.
	</p>
	<p class="source">
		—<i>The Bible</i>, Matthew 19:6
	</p>
</blockquote>

Every rule of pagination boils down to a single principle: break pages with as little disruption to the reading experience as possible. A widow leaves the last line of a paragraph isolated from the rest of the thought. A recto hyphen means a word is interrupted by a page turn. A heading at the bottom of a page removes the title from the section, and the section from the title. 

<h3 id="tradeoffs">
Tradeoffs
</h3>

Pagination involves tradeoffs. Fixing a widow may result in a misaligned spread. Fixing that may result in a loose line or paragraph. What is acceptable in one book, or for one publisher, may be unacceptable to another. What is acceptable in one country, or language, may be unacceptable elsewhere. 

<h3 id="untangling-the-vertical-and-the-horizontal">
Untangling the Vertical and the Horizontal
</h3>

Page breaks are often line breaks. The tiniest change in kerning can make a paragraph longer or shorter, and thus create a widow or an orphan. The work of pagination, as done by typesetters, human or machine, inevitably involves the consideration of the lines of text. And so we will not try too hard to avoid talking about line breaks, when they potentially influence pagination. 


<h2 id="the-spatial-geometry-of-pages-spreads-and-bleeds">
The Spatial Geometry of Pages: Spreads and Bleeds
</h2>

Open a printed book and what you see isn’t a single page, but two pages side by side—a spread.

<figure id="fig-spread1"> <img src="images/Spread.001.png" width="480" alt="diagram of facing text pages" /> <figcaption>Text spread</figcaption></figure>


Books set in Latin scripts typically share some common features.
<ul>
<li>
Books are bound on the left-hand side.
</li>
<li>
Text is written left-to-right and top-to-bottom.
</li>
<li>
Recto and verso pages may not be symmetric. 
</li>
</ul>


<h3 id="crossing-the-gutter">
Crossing the Gutter
</h3>


Large images, tables, or sidebars may extend across both pages of a spread.

<figure id="fig-spread2"> <img src="images/Spread.002.png" width="480" alt="image crossing gutter" /> <figcaption>Image extends across both pages in spread</figcaption></figure>



<h3 id="page-size-orientation-and-arrangement">
Page size, orientation, and arrangement
</h3>


The size, orientation, and arrangement of pages might vary even in a single book:


<ul>
<li>
<dfn>Turned pages</dfn> TK
</li>
<li>
<dfn>Foldouts</dfn> are pages larger than the trim size of the book, folded in order to not extend beyond the other pages. 
</li>
</ul>

<h3 id="bleeds">
Bleeds
</h3>

Books are printed on large sheets of paper, which are then folded and cut. Since the cutting is not infinitely precise, any object that should extend to the very edge of the page in fact needs to extend a bit outside the page boundary. A <dfn>bleed</dfn> is the part of an object that extends outside the page, generally by a small amount such as 9 points. 

<figure id="fig-spread3"> <img src="images/Spread.003.png" width="480" alt="bleed" /> <figcaption>Image bleeds to top and outside</figcaption></figure>

Note: Imposition and related topics are out-of-scope for this document.

<h2 id="hyphenation-and-justification">
Hyphenation and Justification
</h2>

Good hyphenation and justification is critically important to the appearance and readability of text. Print typesetting systems can often achieve very good results, but most online reading systems do this very poorly.

<h3 id="hyphenation">
Hyphenation
</h3>

Text is often easier to read when words are allowed to break at the end of lines, thus avoiding massive variations in word-spacing or margins. But determining acceptable places to break words is a difficult problem:</p>

<div class="example">
<p>All of the following are the results of automated hyphenation algorithms:</p>
<pre>
pre-ached
wee-knights
read-just
leg-ends
ex-acting
co-inage
</pre>
</div>

Words hyphenate differently based on pronunciation or meaning:

<div class="example">
<pre>
 photo-graph
 pho-togra-pher
 
 re-cord (verb)
 rec-ord (noun)
 
 pres-ent (verb)
 pre-sent (noun)
 
 cre-ator
 crea-ture
</pre>
</div>

<h4 id="parameters-for-hyphenation">
Parameters for Hyphenation
</h4>

The following choices need to be made when considering hyphenation of text.

<ol>
<li>
Should this text be hyphenated at all? Hyphenation is generally suppressed in headings. <span class="note">[[CSS3TEXT]] includes a ''hyphens'' property, to enable or disable hyphenation.</span>
</li>
<li>
What’s the shortest word that can be hyphenated? Five or six is typical.
</li>
<li>
What's the minimum number of characters allowed before a hyphen? Two is typical, and is sometimes stated as “two-up.” <span class="issue">PrinceXML has the <code>prince-hyphenate-before</code> property, but this is not in any current CSS draft.</span>
</li>
<li>
What's the minimum number of characters allowed after a hyphen? Three is typical, and can be stated as “three-down.” <span class="issue">PrinceXML has the <code>prince-hyphenate-after</code> property, but this is not in any current CSS draft.</span>
</li>
<li>
How many consecutive lines can end with a hyphen (known as a “ladder”)? Two or three is typical. <span class="issue">PrinceXML has the <code>prince-hyphenate-lines</code> property, but this is not in any current CSS draft.</span>
</li>
<li>
Should capitalized words be hyphenated?
</li>
<li>
Can the last word of a paragraph be hyphenated?
</li>
<li>
Can the last word in a column, page, or spread be hyphenated?
</li>
</ol>


<h4 id="choosing-hyphenation-points">
Choosing hyphenation points
</h4>

A key question is, “who decides what is acceptable?” The answer depends on the language, the culture, the subject matter, and the material being typeset.

<h5 id="language">
Language
</h5>

Each language has its own conventions about hyphenation. U.S. English hyphenates differently than U.K. English. In some European languages, words may be spelled differently when hyphenated.</p>

<div class="example">

<pre>
TK
</pre>

</div>

<p>Of course, the same text may include words from many different languages.</p>


<h5 id="culture">
Culture
</h5>

Even within the same language, authorities differ on the proper hyphenation of words.

<div class="example">
<pre>
in-de-pen-dent (American Heritage Dictionary)
in-de-pend-ent (Webster’s)
</pre>
</div>

Copyeditors will often specify a canonical reference for hyphenation, which is usually a particular edition of a particular dictionary.


<h5 id="subject-matter">
Subject Matter
</h5>

Specialized subject matter may require additional hyphenation dictionaries. This is common in medicine, law, and science.

<h5 id="exceptions">
Exceptions
</h5>

Authors should be able to provide a list of exceptions, which add to or override what the system would normally do. The format for doing so should be easily understood.

<div class="example">
<p>TeX uses the following format. Possible hyphenation positions are indicated with (surprise!) hyphens. Hyphenation should be prevented where hyphens are absent.</p>

<pre>
\hyphenation { 
sur-pris-ingly 
tan-ta-liz-ing-ly 
these
}
</pre>
</div>

Issue: PrinceXML uses a prefixed property <code>prince-hyphenate-patterns: url('en_US.dic');</code> to load a hyphenation dictionary. No current CSS specification includes support for this idea. 



<h3 id="justification">
Justification
</h3>


<h4 id="algorithms">
Algorithms
</h4>


<h5 id="greedy">
Greedy
</h5>


<h5 id="knuth-plass-tex">Knuth-Plass (TeX)
</h5>


<h5 id="adobe-indesign">Adobe (InDesign)
</h5>




<h2 id="paginating-single-column-text">
Paginating Single-Column Text
</h2>

The simplest situation, which is very common, is when the content is only text, in a single column. Aside from chapter and book optimizations (to be discussed later) and line-breaking, the biggest issue is likely to be widows (see <a href='#fig-widow1'>this figure</a> for an example). 


<h3 id="widows">
Widows
</h3>

A <dfn>widow</dfn> is when the last line(s) of a paragraph falls at the top of a page. Publishers have different standards. Most frown on a single line at the top of the page, although some are OK if that line spans at least three-quarters of the page. Others require at least two lines of a paragraph at the top of a page. 

Note: [[css3-break]] includes the ''widows'' and ''orphans'' properties, with integer values. 

Issue: [[css3-break]] does not consider a fractional value for the ''widow'' or ''orphan'' properties.

<figure id="fig-widow1"> <img src="images/image01.png" width="480" alt="diagram of facing text pages with widow at top of verso page" /> <figcaption> Text spread with widow </figcaption> </figure> 

Many typesetting systems have settings to prevent widows. CSS discusses these issues in [[css3-break]]. Unfortunately, these systems usually create another problem when they fix the widow. In <a href='#fig-widow2'>this figure</a>, there&rsquo;s no longer a widow at the top of the page, but since the system merely moved a line from the left page to the right, it left behind an empty line, and the pages no longer align at the bottom. 


<figure id="fig-widow2"> <img src="images/image03.png" width="480" alt="diagram of facing text pages where left page is one line shorter than right page" /> <figcaption> Widow fixed, but pages don’t align </figcaption> </figure> 

More needs to be done. Removing one line of text from each page of the spread, shown in <a href='#fig-widow3'>this figure</a>, solves the problem. 


<figure id="fig-widow3"> <img src="images/image02.png" width="480" alt="diagram of facing text pages where left page is one line shorter than right page" /> <figcaption> Widow fixed by &ldquo;running short.&rdquo; </figcaption> </figure>


<h3 id="orphans">
Orphans
</h3>


An <dfn>orphan</dfn> has two possible meanings in typesetting. It can refer to the minimum number of lines required before a page break (as in [[css3-break]]). It can also refer to the last line of a paragraph in any context. In the former context, many publishers now accept a single line of a paragraph before a page break. For the latter, standards vary widely. Some publishers want the last line to be longer than the paragraph indent. Some require one or two full words, or a certain number of characters. Most avoid having only a fragment of a word as the last line. 


Issue: CSS does not currently address the second meaning of orphan. 

<h3 id="constraints-on-page-depth">
Constraints on page depth
</h3>

In traditional typesetting, the first defense against bad breaks is to change the depth of the page. &ldquo;Running long&rdquo; or &ldquo;running short&rdquo; means including one more (or one less) line of text on each page of the spread, thus sidestepping the previously-identified issue. 


A typical book design includes instructions on whether it&rsquo;s acceptable to run short, long, or (more rarely) both. Often there are also constraints on how many consecutive spreads (or pages) may be altered in this way. If running both long and short, it&rsquo;s usually forbidden to go from one to another without an intervening normal spread. 

Running long or short may affect the space between the last line of text and a page footer or folio. Most publishers prefer  footers to be in a fixed position. If, instead, the space between the last line of text and the footer is fixed, the footer is said to "bounce."

<h3 id="facing-pages">
Facing Pages
</h3>

If a document has facing pages, the publisher usually requires that they align top and bottom. Exceptions include:

<ol>
<li>
It's the last page of a chapter.
</li>
<li>
The page contains no text—only images or tables
</li>
<li>
When aligning facing pages will make some other issue worse
</li>
</ol>

<h3 id="recto-and-verso-hyphens">
Recto and Verso Hyphens
</h3>

Publishers sometimes constrain what characters may appear before a page break. Most commonly, the right-hand page of a spread may not end with a word fragment, as the reader must turn the page before reading the rest of the word. Less common is a prohibition on the verso page ending with a hyphen.


<h3 id="space-breaks-and-ornaments">
Space Breaks and Ornaments
</h3>

Many novels, and some narrative non-fiction books, include small breaks in the text. These are usually represented by one to three blank lines, or by a small ornament or dingbat. Problems arise when these breaks fall at the top or bottom of a page. 


<figure id="fig-spacebreak1"> <img src="images/image04.png" width="480" alt="" /> <figcaption> Space break </figcaption> </figure> 

If, however, the space break falls at the bottom of the page, confusion can result. In <a href='#fig-spacebreak2'>the figure below</a>, it&rsquo;s hard to tell there&rsquo;s a space break, as it just looks like the page is a few lines short. 


<figure id="fig-spacebreak2"> <img src="images/image05.png" width="480" alt="" /> <figcaption> Incorrect: Space break at bottom of page </figcaption> </figure> 

In that case, asterisks or some other ornament is added to the top or bottom of a page, as a visual reminder of the break. To get everything to work out, the spread was run short, and the space break (now with ornament) pushed to the top of the second page: 


<figure id="fig-spacebreak3"> <img src="images/image00.png" width="480" alt="" /> <figcaption> Space break at top of page with asterisks </figcaption> </figure> 


Issue: This is an example where the page position of an element determines its content as well as design. A <code>::page-top</code> or <code>::page-bottom</code> pseudo-element might prove useful.


<h2 id="paragraphs-and-indentation">
Paragraphs and indentation
</h2>



<h2 id="fonts">
Fonts
</h2>

Texts are built from letters. Modern typesetting systems must be able to choose from hundreds or thousands of glyphs depending on the circumstances. 

<h3 id="ligatures">
Ligatures
</h3>

Two or more letters may be better displayed as a single glyph: 

<div class="example">
Example TK
</div>



<h3 id="numbers">
Numbers and math
</h3>

<h4 id="lining-figures">
Lining, oldstyle, and tabular figures
</h4>

Traditionally, text set in mixed-case type should use old-style figures. Text set in all caps should use lining figures. Columns of numbers (such as in tables) are clearer using tabular figures, which are of uniform width. 

<div class="example">
<figure>
<img src="images/onum.png" alt="excerpt from Moby-Dick showing old-style figures" width="480"/>
<figcaption>Old-style figures in text</figcaption> </figure>

<figure>
<img src="images/lnum.png" alt="excerpt from Moby-Dick showing lining figures" width="480"/>
<figcaption>Lining figures in headline</figcaption> </figure>


</div>





<h3 id="alternate-forms">
Alternate forms
</h3>

<h4>
Caps
</h4>

Text may be set in a mix of uppercase and lowercase, exclusively in upper- or lowercase, in small caps, in caps/small caps, etc. In many cases this is purely a design choice, and the displayed text may use a different case than the source document. 

<h4>
Swashes and Stylistic Alternates
</h4>

<div class="example">
<figure>
<img src="images/swsh.png" alt="two identical headings, the top without swashes and the bottom with swashes" width="480"/>
<figcaption>Bickham Script Pro without (top) and with (bottom) swashes</figcaption> </figure>
</div>



<h2 id="initial-capitals">
Initial Capitals
</h2>


Large, decorative letters have been used to start new sections of text since long before printing. In fact, their use predates lowercase letters entirely.


<h3 id="drop-caps">
Drop caps
</h3>


A <dfn>drop cap</dfn> is a larger-than-usual letter at the start of a paragraph, with a baseline at least one line lower than the first baseline of the paragraph. The size of drop caps is usually indicated by how many lines they occupy—two-line and three-line drop caps are the most common. 


<figure id="fig-2-line-drop-cap"> <img src="images/Dropcap-lines.png" width="480" alt="" /> <figcaption> Two-line drop cap </figcaption> </figure> 

Aligning the letter vertically is a challenge. The cap height of the letter should align with the cap height of the first line of text. The baseline of the letter should fall on the baseline of one of the following lines (the second for a 2-line drop cap, etc.). 


<figure id="fig-3-line-drop-cap"> <img src="images/3-line-drop-cap.png" width="480" alt="" /> <figcaption> Three-line drop cap </figcaption> </figure> 


The horizontal position of the drop cap and the surrounding text is also an issue, as variations in glyph shapes may require increasing or decreasing space to the right of the drop cap, and in some cases separate adjustments may be required for each line adjacent to the drop cap.

<figure id="fig-drop-cap-no-runaround"> <img src="images/drop-cap-no-runaround.png" width="480" alt="" /> <figcaption> Drop cap without runaround </figcaption> </figure>

<figure id="fig-drop-cap-runaround"> <img src="images/drop-cap-with-runaround.png" width="480" alt="" /> <figcaption> Drop cap with runaround </figcaption> </figure>

The position of a drop cap in relation to the left margin may also need to be adjusted. Letters like "C" may need to move left slightly to visually align with the left margin.

A drop cap may be desired on a paragraph which starts with a punctuation mark, most often a quotation mark. In this case, one option is to delete the quotation mark entirely.

Issue: Input on techniques for coping with initial punctuation on drop caps would be appreciated.


<h3 id="raised-caps-and-sunken-caps">
Raised caps and sunken caps
</h3>

A <dfn>raised cap</dfn> is a large letter used to start a paragraph, which uses the same baseline as the rest of the first line. A <dfn>sunken cap</dfn> both sinks below the text baseline, and extends above.

<figure>
<img src="images/RaisedCap.png" width="480" alt="raised cap"/>
<figcaption>Raised cap. The initial letter is the size of a 3-line initial, but does not drop.</figcaption>
</figure>


<figure>
<img src="images/SunkenCapA.png" width="480" alt="sunken drop initial"/>
<figcaption>Sunken cap. The letter drops to the second line, but is the size of a three-line initial letter.</figcaption>
</figure>

Note: The CSS Working Group has proposed an initial-letter property to allow for properly-aligned drop caps. See <a href="http://dev.w3.org/csswg/css-inline/#DropInitial">dev.w3.org/csswg/css-inline/#DropInitial</a>.


<h2 id="running-headers-and-footers">
Running headers and footers
</h2>

Books often have material printed at the top and/or bottom of each page, outside the normal content area. These headers or footers may serve as guideposts for reader, fodder for designers, low-tech DRM, or merely a way to know what book your fellow train passenger is reading. There’s more to running headers than is dreamt of in the open web platform…


<h3 id="content">
Content
</h3>

Running heads and footers may contain:

<ul>
<li>
Content from the document: book title, chapter or part titles, author name(s). Indexes and notes sections may have running heads to identify which entries are on a particular page.
</li>
<li>
Content intended only for running heads: shortened versions of chapter titles…</li>
<li>
Counters of all sorts: page numbers, section numbers, chapter numbers. 
</li>
<li>
Ornaments, decorative type, or images
</li>
<li>
Copyright statements or other boilerplate
</li>
<li>
Date and/or time stamps
</li>
<li>
File names
</li>
<li>
Version numbers
</li>
<li>
combinations of the above
</li>
</ul>

In some cases the content of running heads may have an internal structure—a chapter title might have an italic word—or may require different text styles or fonts.



<div class="example">
<figure id="fig-runninghead-ornament"> <img src="images/RunningHead.png" width="480" alt="" /> <figcaption> Running head with text ornament </figcaption> </figure> 

In this example, the running header contains the author name, the page number, and an ornament. This seemingly simple case was quite complex, using [[css3-gcpm]]-like features implemented by PrinceXML.

<pre class="highlight">
@page body:left {
  @top-center { 
    content: flow(verso);
    }
  }

p.verso-cus {
  flow: static(verso);
  content: prince-glyph-index(80);
  font-family: 'Type Embellishments One';
  font-size: 10pt;
  text-align: center;
}

p.verso-cus:before {
  content: counter(page);
  display: inline;
  padding-right: 15pt;
  font-family: 'Garamond 3 LT Std';
  font-style: italic;
  font-size: 10pt;
}

p.verso-cus:after {
  content: string(flow-header-left-rw);
  display: inline;
  padding-left: 15pt;
  font-family: 'Garamond 3 LT Std';
  font-style: italic;
  font-size: 10pt;
}

</pre>

</div>


<h3 id="which-content">
Which content?
</h3>

An element whose content is used in running heads may appear many times on a page. Authors must be able to specify which instance is used. [[css3-gcpm]] provides the start, first, last, and first-except keywords to accomplish this:

<dl> 
	<dt>first</dt>
	<dd>The value of the first assignment on the page is used. If there is no assignment on the page, the "entry value" is used.</dd>
	<dt>start</dt>
	<dd>If the element is the first element on the page, the value of the first assignment is used. Otherwise the "entry value" is used. The "entry value" may be empty if the element hasn’t yet appeared.</dd>
	<dt>last</dt>
	<dd>The "exit value" of the named string is used.</dd>
	<dt>first-except</dt>
	<dd>This is identical to <code>first</code>, except that the empty string is used on the page where the value is assigned.</dd>
</dl>

Issue: Are these values enough to handle indexes, dictionaries, and other use cases?



<h3 id="placement">
Placement
</h3>


Running headers and footers may appear in almost any position on a page.

<ul>
<li>The position of the running head may be different on first pages vs subsequent pages, or the running head may be omitted on first pages</li>
<li>Running heads may align to the inside or outside, and thus be different on left and right pages. </li>
<li>Authors may need to control the layering of running head text (i.e. “z-index”).</li>
<li>The running head may overflow the page boundary (i.e. “bleed”)</li>
<li>The running head may be rotated</li>
</ul>

<div class="note">
<p>Running headers are addressed by [[css3-gcpm]].</p>
<p>EPUB 3.0 has now deprecated support for headers and footers using <code>oeb-page-head</code> and <code>oeb-page-foot</code>.</p>
</div>

<h2 id="heads">
Heads
</h2>

<h3 id="general-considerations">
General Considerations
</h3>

TK

<h3 id="heads-at-the-top-of-a-page">
Heads at the top of a page
</h3>

When a head falls at the top of a page, a spacing adjustment is often necessary. Here's a typical arrangement, with a line and a half of space above the head, and a half-line-space below, so that the text stays on the proper baselines.

<figure id="fig-head-text"> <img src="images/HeadInText.png" width="480" alt="" /> <figcaption> Level One Head in Text </figcaption> </figure> 

If that head appears at the top of the page, the subsequent text will be off by a half-line. 

<figure id="fig-head-text2"> <img src="images/HeadInText2.png" width="480" alt="" /> <figcaption> Head at top of page</figcaption> </figure> 

Everything works out if we add a half-line-space back.

<figure id="fig-head-text3"> <img src="images/HeadInText3.png" width="480" alt="" /> <figcaption> Head sunk to get back on lead</figcaption> </figure> 


<h3 id="heads-at-the-bottom-of-a-page">
Heads at the bottom of a page
</h3>

A head should never be the last thing on a page; it must be followed by two or three lines of text. 


<h3 id="bridge-heads-side-heads-and-run-in-heads">
Bridge heads, side heads, and run-in heads
</h3>

TK



<h2 id="images">
Images
</h2>



<h3 id="tk">
TK
</h3>

<figure id="fig-image-caption"> <img src="images/ImageCaptionRunaround.png" width="480" alt="" /> <figcaption> Figure with caption and runaround </figcaption> </figure> 

Some things to note about this image:

<ol>
<li>
the caption and image are treated as a unit
</li>
<li>
Text runs around the image+caption
</li>
<li>
image runs right up to the gutter of the page (i.e. extends beyond usual content area)
</li>

</ol>



<h3 id="inline-images">
Inline images
</h3>

TK




<h3 id="image-bleeds">Bleeds</h3>

TK

Images that cross spread 

image before callout? 

placing multiple images on page… inside/outside, top/bottom, stagger 

broadside 

placement of caption/title 

<h2 id="tables">
Tables
</h2>


<h3 id="alignment">
Alignment
</h3>

Many tables have specialized requirements for the alignment of cells in a given column.

<h4 id="align-on-character">
Align on character
</h4>

All entries in a given column may need to align to a predetermined character, most commonly a decimal point. Typically, the longest entry in the column should be centered, and then the other entries should align to that entry. 


In some cases, a composite “longest entry” needs to be constructed:

<pre>
|   445.85  |
| 12345.6   |
|     1.234 |
|      .1   |
</pre>

In this case, the user agent should act as if 12345.234 was the longest line, so the margin to the left of 12345.6 will be equal to the margin to the right of 1.234.


When a collection of whole numbers with no decimal points are in a column and are asked to align, the longest whole number should center in the column and the rest of the whole numbers should right align on the right indent of the longest whole number.

If the content of a table cell is being aligned to a character, that content should not have wrapping applied by the rendering system.



<h4 id="flush-left-center-alignment">
Flush left center alignment
</h4>

Issue: What should we call this?

Also known as centering on the longest line, the longest line in a column is found and centered, and other entries in the column are aligned to the left edge of the longest line.

As before, header and footer cells are ignored, and the author should be able to exclude specified cells from the alignment process.

This type of alignment is often used in text, for poetry or prose extracts. 

User agents should not break single-word cells.


<h3 id="table-widths">
Table widths
</h3>


In print, tables are not randomly sized but typically set to one of a few fixed widths. This requirement necessitates that a composition engine know how to “snap to” one of the desired widths. This may help show relationships between separate tables.


broadside 

placement of caption/title 

spread 

multi-page 

continued lines


<h2 id="lists">
Lists, Indexes, and Tables of Contents
</h2>

<h3 id="indexes">
Indexes
</h3>

<h4 id="collapsing-page-ranges">
Collapsing Page Ranges
</h4>

When generating indexes or referring to page ranges, one often ends up with duplicated or sequential numbers.

<div class="example">
<pre>
1, 3, 3, 7, 8, 9, 10, 16
</pre>

This should be formatted as:
<pre>
1, 3, 7–10, 16
</pre>

with duplicates removed and consecutive numbers replaced by ranges.

</div>


<h2 id="footnotes">
Footnotes
</h2>

<blockquote>
<p>Having to read footnotes resembles having to go downstairs to answer the door while in the midst of making love.</p>
<p class="source">—Noël Coward</p>
</blockquote>


In print publishing, a footnote consists of two parts: a reference (often rendered as an asterisk or superscripted number) and the footnote body.

Footnotes themselves can be quite complicated. Footnotes can contain multiple paragraphs, block quotes, poems, lists, and tables. Footnotes can contain other footnotes (an edge case, admittedly, but David Foster Wallace was notorious for this). Footnotes can extend across multiple pages. In short, a footnote is a container that can hold almost anything.

In order to describe footnotes in HTML, one must separate the footnote reference (which is an inline element) from the footnote itself, as HTML frowns on placing complex block structures inside paragraphs. This is quite different from something like DocBook, where the content model allows a footnote element inside a paragraph, and that footnote can itself contain multiple paragraphs, etc. 

<pre class="example highlight">
&lt;p>It was the best of times&lt;span class="ref-footnote-rw">*&lt;/span>, it was the blurst of times.&lt;/p>

&lt;div class="block-rw footnotes-rw">
&lt;p>&lt;span class="num-footnote-rw">*&lt;/span>Oh yes, but the telephone is so impersonal.&lt;/p>
&lt;p>I prefer the hands-on touch you only get with hired goons.&lt;/p>
&lt;/div>
</pre>

There may also be more than one reference to the same footnote.

Footnote handling as described in [[css3-gcpm]] assumes the footnote is coded inline at the point of reference. This situation is under discussion on the www-style list.



<h3 id="inline-footnotes-and-multiple-footnote-regions">
Inline footnotes and multiple footnote regions
</h3>

Some types of footnotes may be displayed inline, as in the top <a href="#fig-footnote-inline">figure</a>. Other books (see <a href="#fig-footnote-regions">below</a>) may have two separate streams of footnotes, requiring two footnote regions.

<figure id="fig-footnote-inline"> <img src="images/exegesis.png" width="480" alt="Page of Hamlet showing inline footnotes above block footnotes" /> <figcaption>Inline footnotes</figcaption> </figure> 

<figure id="fig-footnote-regions"> <img src="images/hamlet.png" width="480" alt="Page of Hamlet showing inline footnotes above block footnotes" /> <figcaption> Multiple footnote regions </figcaption> </figure> 

<figure id="fig-footnote-regions2"> <img src="images/PepysFootnotes.jpg" width="800" alt="" /> <figcaption> Multiple footnote regions #2 </figcaption> </figure> 



<h3 id="at-the-foot-of-what">
At the foot of what?
</h3>

Footnotes usually fall at the bottom of the page, but may need to be at placed at the end of a column, table, sidebar, or other document structure. 


<h3 id="breaking-footnotes-across-pages">
Breaking footnotes across pages
</h3>

Some footnotes can extend across more than one page. Limits on the size of the footnote area(s) may be required, so that a page containing only footnotes is avoided. 

Note: Sometimes, footnotes may require so much space that they cannot all be placed before the end of a document section. In this case, it’s acceptable to have pages that consist only of footnotes.


<h3 id="numbering">
Numbering
</h3>

Three questions must be answered when numbering footnotes. First, which numbering scheme should be used? Second, what are we actually numbering? Third, is the numbering system reset at some point in the document?


<h4 id="numbering-schemes">
Numbering schemes
</h4>

Footnotes are most commonly numbered with arabic numerals, lower-case letters, or a sequence of symbols: *, †, ‡, and §, ||, and #. With symbols, they may be doubled or tripled after exhausting the sequence, but long before |||||| is used, the choice of numbering should be re-evaluated.


<h4 id="what-are-we-counting">
What are we counting?
</h4>

Usually, footnote numbers count footnotes. But in some cases, the reference may be a line number, paragraph number, or section number.


<h4 id="resetting-numbers">
Resetting numbers
</h4>

Footnote numbering may restart with each new chapter, or each new page. The former is common with numeric footnotes, the latter with footnotes using symbols.

Note: Footnotes are addressed by [[css3-gcpm]].

Note: Digital publications often render footnotes differently from print. They may become pop-ups, move to the end of the section, or to the end of the document. We are not currently attempting to document digital best practices around footnotes.


<h2 id="cross-references">
Cross-references
</h2>

Books often contain text that refers to other components of the same book. Such text commonly consists of the name or title of that component, along with a number used to identify that component. 

<blockquote>
as described in Chapter 14
</blockquote>

<blockquote>
From the Aiguille du Midi, follow <b>A16</b> to 2950m
</blockquote>

<blockquote>
Make Anchovy Mayonnaise (page 762), with 6 or 8 anchovies. </blockquote>

<blockquote>
For another example, see Figure 1.4.
</blockquote>

<blockquote>
and equation (31.3) shows it does not!
</blockquote>

Many typesetting systems allow authors to generate numbers for such components. A cross-reference needs to be able to access such generated content from another location in the document.

Note: CSS provides counters to number things; creating cross-references would require a mechanism to access the value of a counter at a particular location. The ''target-counter'' and ''target-counters'' functions in [[css3-content]] are designed to do this.

Issue: [[css3-content]] does not have a mechanism to customize the content of a cross-reference based on the type of element being referred to. See <a href="https://lists.w3.org/Archives/Public/public-digipub/2015Aug/0079.html">https://lists.w3.org/Archives/Public/public-digipub/2015Aug/0079.html</a> and subsequent discussion. 

<h2 id="sidebars">
Sidebars
</h2>


<figure id="fig-sidebar"> <img src="images/Sidebar.jpg" width="480" alt="" /> <figcaption> Sidebar </figcaption> </figure> 

Some things to notice:

<ol>
<li>
The image floats to the top of the column inside the sidebar
</li>
<li>
The columns themselves base-align
</li>
<li>
The sidebar title and “supertitle” are on the same line. 
</li>
</ol>

<h2 id="marginalia">
Marginalia
</h2>

alignment with reference


<h2 id="equations">
Equations
</h2>

Mathematics is a critical part of many books, from learning materials for kindergartners to monographs on physics. 


<h3 id="breaking-equations">
Breaking equations
</h3>

TK


<h3 id="numbering-equations">Numbering equations
</h3>

Equations are often numbered. In the figure below, note that the equations are centered horizontally, the equation number is flush right, and the equation number is centered vertically relative to the equation. 

<figure id="fig-numbering-equations"> <img src="images/Maxwell.png" width="480" alt="Excerpt from Wikipedia article on differential forms, showing Maxwell’s equations in two lines, centered horizontally, with equation number aligned to the right margin and vertically centered" /> <figcaption> Equation Number </figcaption> </figure> 

Note: The alignment in this figure was implemented with [[css-flexbox-1]].

<h3 id="aligning-equations">
Aligning equations
</h3>

Some publishers require that all equations on a page align on the equals sign.

<pre>
    x + 3z = 7 + 2y
    
2x + y + z = 4

Intervening text which may
extend for several lines


   10 + 2y = 3x + 2z
</pre>

Note: the alignment is generally scoped to a page or (more likely) a defined set of equations. 

Note: this is similar to how numbers in a table column may align on a decimal point or other character. 


<h3 id="annotating-equations">
Annotating equations</h3>


<figure id="fig-annotating-equations"> <img src="images/golf_annotated.png" width="480" alt="" /> <figcaption> Annotated Equation from <a href="https://what-if.xkcd.com/85/">XKCD’s What if?</a> </figcaption> </figure> 




<h2 id="columns">
	Columns
</h2>

Often the first page of a chapter or article will be set in a single column, and subsequent pages set in multiple columns.

<figure id="fig-1to2col"> <img src="images/OneColumnToTwoColumns.png" width="480" alt="diagram of facing text pages with one column on first page, and two on second page" /> <figcaption> One column text flows to two columns </figcaption> </figure> 


<h2 id="punctuation">
Punctuation
</h2>

Spacing around punctuation marks is a known obsession of typographers. 


<!-- 
<ul>
<li>
In French, there should be a space before :, !, and ? (but not the full stop). 
</li>
<li>
Americans argue endlessly about the existence and size of spaces around em-dashes.
</li>
<li>
In England, there should be a space between a currency sign and the amount.
</li>
</ul>
 -->

<h3 id="language-specific-spacing-rules">
Language-specific spacing rules
</h3>
 
 <table>
 <tr>
		<td>Punctuation</td>
		<td>English</td>
		<td>French</td>
		<td>Spanish</td>
	</tr>
	<tr>
		<td>Exclamation Point</td>
		<td>!</td>
		<td>[thin space]!</td>
		<td>¡text!</td>
	</tr>
	<tr>
		<td>Colon</td>
		<td>:</td>
		<td>[thin space]:</td>
		<td>:</td>
	</tr>
		<tr>
		<td>Question Mark</td>
		<td>?</td>
		<td>[thin space]?</td>
		<td>¿text?</td>
	</tr>
	<tr>
		<td>Open Quote</td>
		<td>“</td>
		<td>«[thin space]</td>
		<td>“</td>
	</tr>
	<tr>
		<td>Close Quote</td>
		<td>”</td>
		<td>[thin space]»</td>
		<td>”</td>
	</tr>
</table>






<h3 id="em-dashes-and-en-dashes">
Em-dashes and en-dashes
</h3>

To space or not to space? That is the question. Even within publishing houses, arguments continue over the proper display of em-dashes. Some imprints at Hachette use closed em-dashes, others insist on thin spaces around em-dashes. If the same book is to be published in the United Kingdom, em-dashes would be replaced with en-dashes, with larger spaces around them.

Given the subtlety of many of these rules, it’s helpful to use CSS to generate typographically-sophisticated output from material written by lay authors, or to adapt content to varying publisher or language requirements. 


<div class="example">
<p>Older drafts of [[css3-gcpm]] contained a <dfn>text-replace</dfn> property, which has been implemented by PrinceXML.</p>

<pre>
body {
prince-text-replace: "—" "\200A—\200A";
}
</pre>

In this example, we’re adding hair spaces around em-dashes.

</div>


<h3 id="number-formatting">
Number formatting
</h3>

Different languages have different conventions for formatting numbers. Punctuation marks are inserted at specified points in numbers to aid readability. For example, in English commas are used to separate groups of digits, and a period to denote the decimal point.

<div class="example">
<pre>
299,792,458.0
</pre>
</div>

However, in Spanish and Norwegian the roles are reversed, with the period used to group digits, and the comma for the decimal point:

<div class="example">
<pre>
299.792.458,0
</pre>
</div>


<table>
<tr>
<th>Language</th>
<th>Grouping separator</th>
<th>Decimal separator</th>
</tr>
<tr>
<td>Austria, Belgium, Brazil, Canada (fr), Czech Republic, Denmark, Estonia, Finland, France, Germany, Hungary, Italy, Netherlands, Norway, Peru, Poland, Portugal, Romania, South Africa, Spain, Sweden, Switzerland</td>
<td>space</td>
<td>comma</td>
</tr>
<tr>
<td>Argentina, Austria, Brazil, Denmark, Germany, Italy, Portugal, Romania, Slovenia, Spain (older)</td>
<td>period</td>
<td>comma</td>
</tr>
<tr>
<td>Great Britain, United States</td>
<td>comma</td>
<td>period</td>
</tr>
<tr>
<td></td>
<td></td>
<td></td>
</tr>
<tr>
<td></td>
<td></td>
<td></td>
</tr>
<tr>
<td></td>
<td></td>
<td></td>
</tr>
<tr>
<td></td>
<td></td>
<td></td>
</tr>
<tr>
<td></td>
<td></td>
<td></td>
</tr>


</table>

Note: The CSSWG has <a href="https://wiki.csswg.org/ideas/content-formatting">informally proposed</a> a method for formatting numbers.



<h2 id="special-considerations-for-genres">
Special Considerations for Genres
</h2>


<h3 id="education">
Education
</h3>
<ul>
	<li> College textbooks </li>
	<li> Elhi </li>
	<li> Language </li>
	<li> Study guides </li>
</ul>

<h3 id="trade">
Trade
</h3>

<ul>
	<li> Fiction </li>
	<li> Narrative nonfiction </li>
	<li> Children’s </li>
	<li> YA </li>
	<li> Religious 
	<ul>
		<li> Bibles </li>
	</ul>
	</li>
	<li> Travel </li>
	<li> How-to </li>
	<li> Manga/Comics/Graphic Novels </li>
</ul>


<h3 id="stem">
STEM
</h3>


<h3 id="reference">
Reference
</h3>

<ul>
<li>
Legal
</li>
<li>
Dictionaries
</li>
</ul>


<h2 id="digital-issues">
Digital Issues
</h2>


<h2 id="large-scale-issues-in-pagination">
Large-Scale Issues in Pagination
</h2>


<h3 id="book-optimization">
Book optimization
</h3>

In trade publishing, we often know how many pages will be in a book before it is written. The nature of printing and binding also mandate that the number of pages in a book be some multiple of eight, sixteen, or thirty-two pages. Publishers often limit how many blank pages are allowed at the end of a book.


<h3 id="chapter-optimization">
Chapter optimization
</h3>

A chapter that ends with only a few lines of text looks like a mistake, and wastes paper (or electrons!) Generally a page should contain at least five lines of text. 



<h2 id="baseline-grids" class="no-num">Appendix A: Baseline Grids</h2>

A baseline grid is a series of evenly-spaced horizontal alignment lines. This is used to provide a vertical rhythm for a design, to align adjacent content (text or graphics), and to align baselines on facing pages in printed material.


The grid lines can be spaced at line-height intervals or a factor of line-height.


Content can be aligned to the grid in various ways. Roman body text
typically sets the baseline on a grid line. Graphics might have their top,
bottom or both set on grid lines, or be centered between grid lines. Text
blocks (consider a multi-line heading with line-height at 1.4x grid
height) might have their last baseline or first baseline on a grid line,
or have the block's combined height centered between grid lines. Centering
is much more important in ideographic type systems.


If normal layout would result in a misalignment, content shifts down to
the next available grid line.


Sometimes it's necessary to have particular content opt out of aligning to
a grid.


There can be one or more grids per document. Multiple grids can overlap
(body grid and side content grid) or run in series (a vertical stack of
pages). Grids can be nested (think of a document being represented as a
graphic inside another document). A particular piece of content only
aligns to a single grid.



<h2 class="no-num" id="of-leading-and-sinkage-the-language-of-print">Appendix B: Of Leading and Sinkage: The Language of Print</h2>

Translating print designs to the open web platform can be tricky.
<ul>
<li>
vertical distances are usually measured baseline to baseline. 
</li>
<li>
print designers sometimes talk about a "text page" which includes the running head. 
</li>
<li>
The basic text area is often specified with a gutter margin and a text "measure". In [[css3-page]] this area is described by left/right or inside/outside margins.
</li>
</ul>

<dl>
<dt>
Leading
</dt>
<dd>
Line-height
</dd>
<dt>
Recto
</dt>
<dd>
Right-hand page of a spread
</dd>
<dt>
Verso
</dt>
<dd>
Left-hand page of a spread
</dd>
</dl>

<h2 class="no-num" id="the-classical-rules-of-hyphenation-and-pagination">
The Classical Rules of Hyphenation and Pagination
</h2>
<ol>
	<li> At hyphenated line-ends, leave at least two characters behind, and take at least three forward. </li>
	<li> Avoid leaving the stub-end of a hyphenated word, or any word shorter than four letters, as the last line of a paragraph. </li>
	<li> Avoid more than three consecutive hyphenated lines. </li>
	<li> Hyphenate proper names only as a last resort unless they occur with the frequency of common nouns. </li>
	<li> Hyphenate according to the conventions of the language. </li>
	<li> Link short numerical and mathematical expressions with hard spaces. </li>
	<li> Avoid beginning more than two consecutive lines with the same word. </li>
	<li> Never begin a page with the last line of a multi-line paragraph. </li>
	<li> Balance facing pages by moving single lines. </li>
	<li> Avoid hyphenated breaks where the text is interrupted. </li>
	<li> Abandon any and all rules of hyphenation and pagination that fail to serve the needs of the text. </li>
</ol>


<h2 class="no-num" id="further-reading">
Further Reading
</h2>

<p>Bringhurst, Robert. <i>The Elements of Typographic Style</i></p>
<p>Felici, Jim. <i>The Complete Manual of Typography</i></p>
<p>Haralambous, Yannis. <i>Fonts &amp; Encodings: From Advanced Typography to Unicode and Everything in Between</i></p>
<p>Haslam, Andrew. <i>Book Design</i></p>
<p>Highsmith, Cyrus. <i>Inside Paragraphs</i></p>
<p>Kane, John. <i>A Type Primer</i></p>
<p>Knuth, Donald. <i>Digital Typography</i></p>
<p>Lawson, Alexander. <i>Anatomy of a Typeface</i></p>
<p>Mitchell; Wightman. <i>Book Typography</i></p>
<p>Nickel, Kristina. <i>Ready to Print</i></p>
<p>Steer, Vincent. <i>Printing Design and Layout</i> (1948)</p>
<p>Tracy, Walter. <i>Letters of Credit: A View of Type Design</i></p>
<p>Tschichold, Jan. <i>The Form of the Book: Essays on the Morality of Good Design</i></p>


<h2 class="no-num" id="acknowledgments">Acknowledgments</h2>

Eric Aubourg, Luc Audrain, Bert Bos, Tom Byrer, James Clark, Brady Duga, Ivan Herman, Tony Graham, Bill Kasdorf, Jean Kaplansky, Sanders Kleinfeld, Liam Quin, Alan Stearns, Tzviya Siegman

